<?php
class Email {
	public $recipient;
	public $sender;
	public $body;
	/* ... */
}

class PartionedEmailDB {
	public $databases;
	public function __construct() {
		$this->databases[0] = new DB_Mysql_Email0;
		$this->databases[1] = new DB_Mysql_Email1;
		$this->databases[2] = new DB_Mysql_Email2;
		$this->databases[3] = new DB_Mysql_Email3;
	}
	public function insertEmail(Email $email) {
		$query = "INSERT INTO emails 
				(recipient, sender, body)
			  VALUES(:1, :2, :3)";
		$hash = crc32($email->recipient) % count($this->databases);
		$this->databases[$hash]->prepare($query)->execute($email->recipient, $email->sender, $email->body);
	}
	public function retrieveEmails($recipient) {
		$query = "SELECT * FROM emails WHERE recipient = :1";
		$hash = crc32($email->recipient) % count($this->databases);
		$result = $this->databases[$hash]->prepare($query)->execute($recipient);
		while($hr = $result->fetch_assoc) {
			$retval[] = new Email($hr);
		}
	}
}
		

